package es.gva.cit.jgdal;

import java.io.IOException;

import junit.framework.TestCase;

/**
 * Test de acceso a datos de las bandas de una imagen.
 * @author Miguel ngel Querol Carratal <miguelangel.querol@iver.es>
 *
 */
public class TestReadBandData extends TestCase{
	private Gdal gdal = null;
	private GdalRasterBand band = null;
	private String baseDir = "./test-images/";
	private String file1 = baseDir + "testGdal.tif";
	
	public void start(){
		try {
			setUp();
			testStack();
		} catch (GdalException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	public void setUp() throws GdalException, IOException{
		gdal = new Gdal();
		gdal.open(file1, Gdal.GA_Update);
	}
	
	public void testStack() throws GdalException, IOException{
		//Llamada sin dominio
		metadata = gdal.getMetadata();
		assertNotNull("No se han devuelto metadatos", metadata);
		for (int i = 0 ; i<metadata.length ; i++){
			System.out.println("Metadato: " + metadata[i]);
		}
		
		//Llamada con dominio "Image Structure Metadata"
		metadata = gdal.getMetadata("Image Structure Metadata");
		assertNotNull("No se han devuelto metadatos", metadata);
		for (int i = 0 ; i<metadata.length ; i++){
			System.out.println("Metadato: " + metadata[i]);
		}
		
		//Comprobacin del tamao de la imagen
		assertEquals(842, gdal.getRasterXSize());
		assertEquals(1023, gdal.getRasterYSize());
		
		//Comprobacin del nmero de bandas
		assertEquals(4, gdal.getRasterCount());
		
		//Comprobacin del driver de la imagen
		assertEquals("GTiff", gdal.getDriverShortName());
		
		//Comprobacin del acceso a las bandas
		for (int i = 0 ; i < gdal.getRasterCount() ; i++){
			assertNotNull(gdal.getRasterBand(i+1));
		}
	}
}
